# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#no jars in this native build, so skip signing
%define _jarsign_opts --nocopy

%define reltag .Final
%define namedversion %{version}%{reltag}
%define jarname mod-cluster

%if "%{?rhel}" == "6"
%bcond_without zip
%else
%bcond_with zip
%endif

Name:		mod_cluster-native
Summary: 	JBoss mod_cluster for Apache httpd
Version: 	1.2.6
Release: 	1%{reltag}.redhat_1%{?dist}
Epoch:		0
License: 	LGPLv3
Group: 		Applications/System
URL:		http://www.jboss.org/
# git clone git://git.app.eng.bos.redhat.com/mod_cluster.git
# cd mod_cluster && git checkout 1.2.6.Final
#HEAD is now at b12f068... [maven-release-plugin] prepare release 1.2.6.Final
# rm -fr .git .gitignore
# cd ../ && mv mod_cluster mod_cluster-1.2.6.Final
# tar czf mod_cluster-1.2.6.Final.tar.gz mod_cluster-1.2.6.Final
Source0:        mod_cluster-1.2.6.Final.tar.gz
Source1:        %{name}.conf
Source2:        %{name}.te

BuildRoot:      %{_tmppath}/%{name}-buildroot
BuildRequires:	httpd-devel
BuildRequires:	autoconf
BuildRequires:	zip
#For SELinux
%if "%{?rhel}" == "6"
BuildRequires: selinux-policy
%else
#%{_datadir}/selinux/devel/Makefile is in -devel on RHEL 5
BuildRequires: selinux-policy-devel
%endif

%if "%{?rhel}" == "6"
Requires(post): policycoreutils-python
Requires(postun): policycoreutils-python
%else
Requires(post): policycoreutils
Requires(postun): policycoreutils
%endif

Requires:   httpd >= 0:2.2.15

%description
JBoss mod_cluster for Apache httpd.
NOTE: Apache httpd 2.2.15 or newer is needed.

%if %with zip
%package src-zip
Summary:     Container for the source distribution of %{name}
Group:       Development

%description src-zip
Container for the source distribution of %{name}.
%endif

%prep
%setup -q -n mod_cluster-%{namedversion}

%build
zip -q -r ../%{name}-%{namedversion}-src.zip native/*

%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
pushd native
for i in advertise mod_manager mod_proxy_cluster mod_slotmem
do
pushd $i
sh buildconf
./configure --with-apxs="%{apxs}"
make CFLAGS=-fno-strict-aliasing
popd
done
popd

%install
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT/%{aplibdir}/
cp -p native/*/*.so ${RPM_BUILD_ROOT}/%{aplibdir}/
install -d -m 755 $RPM_BUILD_ROOT/%{_localstatedir}/cache/mod_cluster

install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/
install -p -m 644 %{SOURCE1} \
        $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/mod_cluster.conf

%if %with zip
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
install -p -m 644 ../%{name}-%{namedversion}-src.zip \
        $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/
%endif

# for SELinux
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}
mkdir selinux
pushd selinux
cp -p %{SOURCE2} .
touch %{name}.fc %{name}.if
make -f %{_datadir}/selinux/devel/Makefile
install -p -m 644 -D %{name}.pp $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}/%{name}.pp
popd

%clean
rm -Rf $RPM_BUILD_ROOT

%post
if [ $1 -eq 1 ] ; then
    /sbin/restorecon -Fr %{aplibdir} 2>/dev/null || :
    %{_sbindir}/semanage port -a -t http_port_t -p udp 23364 >/dev/null 2>&1 || :
    %{_sbindir}/semanage port -a -t http_port_t -p tcp 6666 >/dev/null 2>&1 || :
    %{_sbindir}/semanage fcontext -a -t httpd_cache_t '/var/cache/mod_cluster(/.*)?' >/dev/null 2>&1 || :
    /sbin/restorecon -R /var/cache/mod_cluster >/dev/null 2>&1 || :
    %{_sbindir}/semodule -i %{_datadir}/selinux/packages/%{name}/%{name}.pp 2>/dev/null || : 
fi 

%preun
if [ $1 -eq 0 ] ; then
  %{_sbindir}/semanage port -d -t http_port_t -p udp 23364 2>&1 || :
  %{_sbindir}/semanage port -d -t http_port_t -p tcp 6666 2>&1 || :
  %{_sbindir}/semodule -r mod_cluster 2>&1 || :
fi 

%files
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%defattr(0644,root,root,0755)
%doc JBossORG-EULA.txt
%doc lgpl.txt
%doc README.txt
%doc release.txt
%dir %{_localstatedir}/cache/mod_cluster
%attr(0755,root,root) %{aplibdir}/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_cluster.conf
# for SELinux
%dir %{_datadir}/selinux/packages/%{name}
%{_datadir}/selinux/packages/%{name}/%{name}.pp

%if %with zip
%files src-zip
%defattr(-,root,root,-)
%{_javadir}/jbossas-fordev/*
%endif

%changelog
* Tue Sep 10 2013 Permaine Cheung <pcheung@redhat.com> - 0:1.2.6-1.Final.redhat_1
- 1.2.6.Final-redhat-1

* Mon Sep 09 2013 Permaine Cheung <pcheung@redhat.com> - 0:1.2.4-2.Final.redhat_2
- Bump suffix to -redhat-2

* Tue Sep 03 2013 Permaine Cheung <pcheung@redhat.com> - 0:1.2.4-2.Final.redhat_1
- Update R: httpd as per BZ#1003955

* Thu Apr 25 2013 Permaine Cheung <pcheung@redhat.com> - 0:1.2.4-1.Final.redhat_1
- 1.2.4.Final-redhat-1
- Remove patch that has already been incorporated in the new tag

* Tue Feb 05 2013  Permaine Cheung <pcheung@redhat.com> - 0:1.2.3-3.Final.redhat_1
- Add .redhat_1 to Release: tag

* Wed Nov 21 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.3-3.Final
- Add patch for JBPAPP6-1170

* Thu Oct 18 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.3-2.Final
- Remove .git* files in src tar ball

* Thu Oct 18 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.3-1.Final
- 1.2.3.Final

* Thu Sep 13 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.2-1.1.Final
- Only include native dir in src zip

* Mon Sep 10 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.2-1.Final
- 1.2.2.Final

* Fri Sep 07 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.1-5.Final
- Fix SELinux R: on RHEL 6

* Tue Jun 12 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.1-4.Final
- Add SELinux policy
- Add mod_cluster.conf

* Wed May 09 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.1-3.Final
- 1.2.1.Final

* Thu Apr 26 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.1-2.1.Beta2
- Do not build src-zip subpackage on RHEL 5

* Thu Apr 26 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.1-2.Beta2
- Add src-zip subpackage for EWS src zip creation

* Tue Apr 10 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.1-1.Beta2
- 1.2.1.Beta2

* Wed Mar 21 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.1-0.Beta1
- 1.2.1.Beta1

* Tue Feb 14 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.0-0.Final
- 1.2.0.Final

* Tue Jan 31 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.0-0.Beta4
- 1.2.0.Beta4

* Thu Jan 05 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.2.0-0.Beta3
- 1.2.0.Beta3

* Wed Dec 07 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.2.0-0.Beta1
- 1.2.0.Beta1 for EAP 6

* Thu Nov 24 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.1.3-1.Final
- 1.1.3.Final for EAP 6

* Mon Aug 15 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.0.10-3.1.1.GA_CP02
- Upgrade to 1.0.10.GA_CP02

* Fri Jun 10 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.0.10-2.1.1.GA_CP01
- Upgrade to 1.0.10.GA_CP01

* Mon Apr 18 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.0.10-1.1.1
- Upgrade to 1.0.10.GA

* Mon Mar 21 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.0.9-1.1
- Upgrade to 1.0.9.GA

* Thu Feb 17 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.0.8-2.1.1
- Fix Release tag

* Wed Feb 16 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.0.8-1.1.1
- Upgrade to 1.0.8.GA

* Fri Jan 07 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.0.6-1.1.1
- Upgrade to 1.0.6.GA

* Wed Nov 24 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.5-1.1.1
- Upgrade to 1.0.5.GA

* Mon Nov 22 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.4-1.1.5
- Skip signing as this is a native build
- Fix License tag

* Thu Oct 14 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.4-1.1.4
- Fix file permission

* Thu Oct 14 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.4-1.1.3
- Fix file permission

* Thu Oct 14 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.4-1.1.2
- Fix permission

* Wed Oct 06 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.4-1.1.1
- Rebuild

* Wed Jul 28 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.4-1.1
- Upgrade to 1.0.4.GA
- Remove patches that are already incorporated in the tag

* Thu Jun 24 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.3-9.1
- Remove R: httpd 2.2.8 and add a note in description

* Tue Jun 22 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.3-8.1
- Build with no-strict-aliasing as suggested by rpmdiff

* Wed May 26 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.3-7.2
- Split up mod_cluster into mod-cluster and mod_cluster-native

* Tue May 25 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.3-6.1
- Add patch for JBPAPP-3936, 4046, 4307
- Adjust depmap

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.3-3.3.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.0.3-3.3
- Rebuild

* Thu Apr 01 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.3-3.2
- Build with jars
- Revert the changes to work with httpd instead of httpd22

* Tue Feb 09 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.0.3-3.1
- Merge with RHEL-4

* Mon Jan 25 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.3-2.1
- Rebuild

* Mon Jan 18 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.3-1
- Upgrade to 1.0.3
- Merge with RHEL-4-EP-5 branch

* Fri Nov 06 2009 Permaine Cheung <pcheung@redhat.com> - 0:1.0.2-5.1
- Do not build jars as we don't have all the dependencies on RHEL 5

* Thu Nov 05 2009 Permaine Cheung <pcheung@redhat.com> - 0:1.0.2-5
- Fix location of zip

* Thu Nov 05 2009 Permaine Cheung <pcheung@redhat.com> - 0:1.0.2-4
- Fix Requires:

* Thu Nov 05 2009 Permaine Cheung <pcheung@redhat.com> - 0:1.0.2-3
- Build native .so for httpd and put them in the main package
- Rename the package that includes jars and sar for jbossas to -jbossas
- Add load-demo.war back in demo/server
- Add .so to zip
- Add src-zip

* Mon Nov 02 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-2
- Add license and release notes to the main package
- Remove .dir extension from sar directory name
- Add mod_cluster.jar to sar directory
- Change sub-package names to jbossweb2 and tomcat6 to clarify versions
- Explode contents of load-demo.war inside server subdirectory in the demo sub-package

* Tue Sep 15 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-1
- Brew build
- Relax version for httpd-devel
